Subject: Re: bug#22549: 25.0.50; Tooltips placed outside of screen limits

From: Eli Zaretskii <[email-masked]>
Date: Thu, 04 Feb 2016 18:43:21 +0200

> From: Óscar Fuentes <[email-masked]>
> Date: Thu, 04 Feb 2016 17:20:47 +0100
> Cc: [email-masked]
> 
> >> The MS Windows port places the tooltips taking into account the screen
> >> edges.
> >
> > So does the Lucid port.  Something else must be at work here.
> 
> I think I know what is happening.
> 
> I have two monitors, side by side, simulating a continuous display. The
> monitor on the left side, where Emacs is displayed, has a vertical
> resolution of 1050 pixels while the monitor on the right side has a
> vertical resolution of 1200 points. Emacs is using the vertical
> resolution of the virtual display (the largest of the two monitors, i.e.
> 1200 points) instead of the resolution of the monitor that hosts the
> Emacs frame.
> 
> Something similar happens for the horizontal overflow: the dimensions of
> the virtual desktop are used instead of the dimensions of the monitor.

I arrived at the same conclusion by looking at the X code: the APIs
called by x_display_pixel_height and x_display_pixel_width return
information about the entire virtual screen, not about the current
monitor.  We need to use different APIs in the case of tooltip
positioning.